Index: palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3556)
+++ palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3557)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Updated documentation
+!
+! 
+! 3537 2018-11-20 10:53:14Z eckhard
 ! Read COSMO domain extents and soil depths from input files
 ! Report averaging mode and debugging mode in log
@@ -69,5 +73,5 @@
 ! Authors:
 ! --------
-! @author Eckhard Kadasch
+!> @author Eckhard Kadasch (Deutscher Wetterdienst, Offenbach)
 !
 !------------------------------------------------------------------------------!
@@ -193,101 +197,109 @@
     INTEGER ::  step_hour !< number of hours between forcing time steps
 
-    LOGICAL ::  init_variables_required
-    LOGICAL ::  boundary_variables_required
-    LOGICAL ::  ls_forcing_variables_required
-    LOGICAL ::  profile_grids_required
-    LOGICAL ::  surface_forcing_required
+    LOGICAL ::  init_variables_required       !< flag controlling whether init variables are to be processed
+    LOGICAL ::  boundary_variables_required   !< flag controlling whether boundary grids are to be allocated and boundary variables are to be computed
+    LOGICAL ::  ls_forcing_variables_required !< flag controlling whether large-scale forcing variables are to be computed
+    LOGICAL ::  surface_forcing_required      !< flag controlling whether surface forcing variables are to be computed
 
     TYPE(nc_var), ALLOCATABLE, TARGET ::  input_var_table(:)  !< table of input variables
     TYPE(nc_var), ALLOCATABLE, TARGET ::  output_var_table(:) !< table of input variables
-    TYPE(nc_var)                      ::  cosmo_var           !< COSMO-DE dummy variable, used for reading HHL, rlon, rlat
+    TYPE(nc_var)                      ::  cosmo_var           !< COSMO dummy variable, used for reading HHL, rlon, rlat
 
     TYPE(grid_definition), TARGET ::  palm_grid                       !< PALM-4U grid in the target system (COSMO-DE rotated-pole)
     TYPE(grid_definition), TARGET ::  palm_intermediate               !< PALM-4U grid with coarse vertical grid wiht levels interpolated from COSMO-DE grid
     TYPE(grid_definition), TARGET ::  cosmo_grid                      !< target system (COSMO-DE rotated-pole)
-    TYPE(grid_definition), TARGET ::  scalars_east_grid               !< 
-    TYPE(grid_definition), TARGET ::  scalars_west_grid               !< 
-    TYPE(grid_definition), TARGET ::  scalars_north_grid              !< 
-    TYPE(grid_definition), TARGET ::  scalars_south_grid              !< 
-    TYPE(grid_definition), TARGET ::  scalars_top_grid                !< 
-    TYPE(grid_definition), TARGET ::  scalars_east_intermediate       !< 
-    TYPE(grid_definition), TARGET ::  scalars_west_intermediate       !< 
-    TYPE(grid_definition), TARGET ::  scalars_north_intermediate      !< 
-    TYPE(grid_definition), TARGET ::  scalars_south_intermediate      !< 
-    TYPE(grid_definition), TARGET ::  scalars_top_intermediate        !< 
-    TYPE(grid_definition), TARGET ::  u_initial_grid                  !< 
-    TYPE(grid_definition), TARGET ::  u_east_grid                     !< 
-    TYPE(grid_definition), TARGET ::  u_west_grid                     !< 
-    TYPE(grid_definition), TARGET ::  u_north_grid                    !< 
-    TYPE(grid_definition), TARGET ::  u_south_grid                    !< 
-    TYPE(grid_definition), TARGET ::  u_top_grid                      !< 
-    TYPE(grid_definition), TARGET ::  u_initial_intermediate          !<
-    TYPE(grid_definition), TARGET ::  u_east_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  u_west_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  u_north_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  u_south_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  u_top_intermediate              !< 
-    TYPE(grid_definition), TARGET ::  v_initial_grid                  !< 
-    TYPE(grid_definition), TARGET ::  v_east_grid                     !< 
-    TYPE(grid_definition), TARGET ::  v_west_grid                     !< 
-    TYPE(grid_definition), TARGET ::  v_north_grid                    !< 
-    TYPE(grid_definition), TARGET ::  v_south_grid                    !< 
-    TYPE(grid_definition), TARGET ::  v_top_grid                      !< 
-    TYPE(grid_definition), TARGET ::  v_initial_intermediate          !<
-    TYPE(grid_definition), TARGET ::  v_east_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  v_west_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  v_north_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  v_south_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  v_top_intermediate              !< 
-    TYPE(grid_definition), TARGET ::  w_initial_grid                  !< 
-    TYPE(grid_definition), TARGET ::  w_east_grid                     !< 
-    TYPE(grid_definition), TARGET ::  w_west_grid                     !< 
-    TYPE(grid_definition), TARGET ::  w_north_grid                    !< 
-    TYPE(grid_definition), TARGET ::  w_south_grid                    !< 
-    TYPE(grid_definition), TARGET ::  w_top_grid                      !< 
-    TYPE(grid_definition), TARGET ::  w_initial_intermediate          !<
-    TYPE(grid_definition), TARGET ::  w_east_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  w_west_intermediate             !< 
-    TYPE(grid_definition), TARGET ::  w_north_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  w_south_intermediate            !< 
-    TYPE(grid_definition), TARGET ::  w_top_intermediate              !< 
-
-    TYPE(grid_definition), TARGET ::  north_averaged_scalar_profile
-    TYPE(grid_definition), TARGET ::  south_averaged_scalar_profile
-    TYPE(grid_definition), TARGET ::  west_averaged_scalar_profile
-    TYPE(grid_definition), TARGET ::  east_averaged_scalar_profile
-    TYPE(grid_definition), TARGET ::  averaged_scalar_profile
-    TYPE(grid_definition), TARGET ::  averaged_w_profile
+    TYPE(grid_definition), TARGET ::  scalars_east_grid               !< grid for eastern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_west_grid               !< grid for western scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_north_grid              !< grid for northern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_south_grid              !< grid for southern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_top_grid                !< grid for top scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_east_intermediate       !< intermediate grid for eastern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_west_intermediate       !< intermediate grid for western scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_north_intermediate      !< intermediate grid for northern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_south_intermediate      !< intermediate grid for southern scalar boundary condition
+    TYPE(grid_definition), TARGET ::  scalars_top_intermediate        !< intermediate grid for top scalar boundary condition
+    TYPE(grid_definition), TARGET ::  u_initial_grid                  !< grid for u initial condition
+    TYPE(grid_definition), TARGET ::  u_east_grid                     !< grid for eastern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_west_grid                     !< grid for western u boundary condition
+    TYPE(grid_definition), TARGET ::  u_north_grid                    !< grid for northern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_south_grid                    !< grid for southern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_top_grid                      !< grid for top u boundary condition
+    TYPE(grid_definition), TARGET ::  u_initial_intermediate          !< intermediate grid for u initial condition
+    TYPE(grid_definition), TARGET ::  u_east_intermediate             !< intermediate grid for eastern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_west_intermediate             !< intermediate grid for western u boundary condition
+    TYPE(grid_definition), TARGET ::  u_north_intermediate            !< intermediate grid for northern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_south_intermediate            !< intermediate grid for southern u boundary condition
+    TYPE(grid_definition), TARGET ::  u_top_intermediate              !< intermediate grid for top u boundary condition
+    TYPE(grid_definition), TARGET ::  v_initial_grid                  !< grid for v initial condition
+    TYPE(grid_definition), TARGET ::  v_east_grid                     !< grid for eastern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_west_grid                     !< grid for western v boundary condition
+    TYPE(grid_definition), TARGET ::  v_north_grid                    !< grid for northern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_south_grid                    !< grid for southern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_top_grid                      !< grid for top v boundary condition
+    TYPE(grid_definition), TARGET ::  v_initial_intermediate          !< intermediate grid for v initial condition
+    TYPE(grid_definition), TARGET ::  v_east_intermediate             !< intermediate grid for eastern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_west_intermediate             !< intermediate grid for western v boundary condition
+    TYPE(grid_definition), TARGET ::  v_north_intermediate            !< intermediate grid for northern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_south_intermediate            !< intermediate grid for southern v boundary condition
+    TYPE(grid_definition), TARGET ::  v_top_intermediate              !< intermediate grid for top v boundary condition
+    TYPE(grid_definition), TARGET ::  w_initial_grid                  !< grid for w initial condition
+    TYPE(grid_definition), TARGET ::  w_east_grid                     !< grid for eastern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_west_grid                     !< grid for western w boundary condition
+    TYPE(grid_definition), TARGET ::  w_north_grid                    !< grid for northern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_south_grid                    !< grid for southern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_top_grid                      !< grid for top w boundary condition
+    TYPE(grid_definition), TARGET ::  w_initial_intermediate          !< intermediate grid for w initial condition
+    TYPE(grid_definition), TARGET ::  w_east_intermediate             !< intermediate grid for eastern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_west_intermediate             !< intermediate grid for western w boundary condition
+    TYPE(grid_definition), TARGET ::  w_north_intermediate            !< intermediate grid for northern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_south_intermediate            !< intermediate grid for southern w boundary condition
+    TYPE(grid_definition), TARGET ::  w_top_intermediate              !< intermediate grid for top w boundary condition
+    TYPE(grid_definition), TARGET ::  north_averaged_scalar_profile   !< grid of the northern scalar averaging region
+    TYPE(grid_definition), TARGET ::  south_averaged_scalar_profile   !< grid of the southern scalar averaging region
+    TYPE(grid_definition), TARGET ::  west_averaged_scalar_profile    !< grid of the western scalar averaging region
+    TYPE(grid_definition), TARGET ::  east_averaged_scalar_profile    !< grid of the eastern scalar averaging region
+    TYPE(grid_definition), TARGET ::  averaged_scalar_profile         !< grid of the central scalar averaging region
+    TYPE(grid_definition), TARGET ::  averaged_w_profile              !< grid of the central w-velocity averaging region
 
     TYPE(io_group), ALLOCATABLE, TARGET ::  io_group_list(:)  !< List of I/O groups, which group together output variables that share the same input variable
  
     NAMELIST /inipar/ nx, ny, nz, dx, dy, dz, longitude, latitude,             &
-                      dz_max, dz_stretch_factor, dz_stretch_level,             & !< old grid stretching parameters
-                      dz_stretch_level_start, dz_stretch_level_end               !< new grid stretching parameters
+                      dz_max, dz_stretch_factor, dz_stretch_level,             &
+                      dz_stretch_level_start, dz_stretch_level_end
     NAMELIST /d3par/  end_time
     
-    CHARACTER(LEN=LNAME) ::  nc_source_text     = ''  !< Text describing the source of the output data, e.g. 'COSMO-DE analysis from ...'
-    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  flow_files
-    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  soil_moisture_files
-    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  soil_files
-    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  radiation_files
-    CHARACTER(LEN=SNAME) ::  input_prefix         !< Prefix of input files, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  flow_prefix          !< Prefix of flow input files, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  soil_prefix          !< Prefix of soil input files, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< Prefix of radiation input files, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  soilmoisture_prefix  !< Prefix of input files for soil moisture spin-up, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  flow_suffix          !< Suffix of flow input files, e.g. 'flow'
-    CHARACTER(LEN=SNAME) ::  soil_suffix          !< Suffix of soil input files, e.g. 'soil'
-    CHARACTER(LEN=SNAME) ::  radiation_suffix     !< Suffix of radiation input files, e.g. 'radiation'
-    CHARACTER(LEN=SNAME) ::  soilmoisture_suffix  !< Suffix of input files for soil moisture spin-up, e.g. 'soilmoisture'
+    CHARACTER(LEN=LNAME) ::  nc_source_text = ''  !< Text describing the source of the output data, e.g. 'COSMO-DE analysis from ...'
+
+    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  flow_files          !< list of atmospheric input files (<prefix>YYYYMMDDHH-flow.nc)
+    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  soil_moisture_files !< list of precipitation input files (<prefix>YYYYMMDDHH-soilmoisture.nc) 
+    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  soil_files          !< list of soil input files (temperature, moisture, <prefix>YYYYMMDDHH-soil.nc)
+    CHARACTER(LEN=PATH), ALLOCATABLE, DIMENSION(:) ::  radiation_files     !< list of radiation input files (<prefix>YYYYMMDDHH-rad.nc)
+
+    CHARACTER(LEN=SNAME) ::  input_prefix         !< prefix of input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  flow_prefix          !< prefix of flow input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soil_prefix          !< prefix of soil input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< prefix of radiation input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  soilmoisture_prefix  !< prefix of input files for soil moisture spin-up, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  flow_suffix          !< suffix of flow input files, e.g. 'flow'
+    CHARACTER(LEN=SNAME) ::  soil_suffix          !< suffix of soil input files, e.g. 'soil'
+    CHARACTER(LEN=SNAME) ::  radiation_suffix     !< suffix of radiation input files, e.g. 'radiation'
+    CHARACTER(LEN=SNAME) ::  soilmoisture_suffix  !< suffix of input files for soil moisture spin-up, e.g. 'soilmoisture'
                           
-    TYPE(nc_file) ::  output_file
-
-    TYPE(inifor_config) ::  cfg !< Container of INIFOR configuration
+    TYPE(nc_file) ::  output_file !< metadata of the dynamic driver 
+
+    TYPE(inifor_config) ::  cfg !< container of the INIFOR command-line configuration
 
  CONTAINS
     
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This routine initializes INIFOR. This includes parsing command-line options,
+!> setting the names of the input and output files, reading INIFOR's namelist
+!> file as well as reading in and setting grid parameters for defining
+!> interplation grids later in setup_grids().
+!------------------------------------------------------------------------------!
     SUBROUTINE setup_parameters()
-       INTEGER ::  k
+       INTEGER ::  k !< loop index
 
 !
@@ -300,20 +312,24 @@
        start_hour_soilmoisture = - (4 * 7 * 24) - 2
 
-       ! COSMO-DE default rotated pole
+!
+!--    COSMO-DE and -D2 rotated pole position
        phi_n     =   40.0_dp * TO_RADIANS
        phi_equat =   50.0_dp * TO_RADIANS
        lambda_n  = -170.0_dp * TO_RADIANS
 
-       ! Defaultmain centre (_c) of the PALM-4U grid in the geographical system (_g)
+!
+!--    Defaultmain centre (_c) of the PALM-4U grid in the geographical system (_g)
        origin_lat = 52.325079_dp * TO_RADIANS ! south-west of Berlin, origin used for the Dec 2017 showcase simulation
        origin_lon = 13.082744_dp * TO_RADIANS
        cfg % z0 = 35.0_dp
 
-       ! Default atmospheric parameters
+!
+!--    Default atmospheric parameters
        cfg % ug = 0.0_dp
        cfg % vg = 0.0_dp
        cfg % p0 = P_SL
 
-       ! Parameters for file names
+!
+!--    Parameters for file names
        start_hour_flow = 0
        start_hour_soil = 0
@@ -323,5 +339,5 @@
        step_hour = FORCING_STEP
 
-       input_prefix = 'laf'  ! 'laf' for COSMO-DE analyses
+       input_prefix = 'laf'
        cfg % flow_prefix = input_prefix
        cfg % input_prefix = input_prefix
@@ -342,5 +358,6 @@
 !------------------------------------------------------------------------------
 
-       ! Set default paths and modes
+!
+!--    Set default paths and modes
        cfg % input_path         = './'
        cfg % hhl_file           = ''
@@ -353,5 +370,6 @@
        cfg % averaging_mode = 'level'
 
-       ! Overwrite defaults with user configuration
+!
+!--    Overwrite defaults with user configuration
        CALL parse_command_line_arguments( cfg )
 
@@ -380,6 +398,6 @@
        END IF
 
-
-       ! Set default file paths, if not specified by user.
+!
+!--    Set default file paths, if not specified by user.
        CALL normalize_path(cfg % input_path)
        IF (TRIM(cfg % hhl_file) == '')  cfg % hhl_file = TRIM(cfg % input_path) // 'hhl.nc'
@@ -399,5 +417,6 @@
 
  CALL run_control('time', 'init')
-       ! Read in namelist parameters
+ !
+ !--   Read in namelist parameters
        OPEN(10, FILE=cfg % namelist_file)
        READ(10, NML=inipar) ! nx, ny, nz, dx, dy, dz
@@ -408,5 +427,6 @@
        end_hour = CEILING( end_time / 3600.0 * step_hour )
 
-       ! Generate input file lists
+!
+!--    Generate input file lists
        CALL get_input_file_list(                                               &
           cfg % start_date, start_hour_flow, end_hour, step_hour,              &
@@ -437,5 +457,6 @@
 
  CALL run_control('time', 'init')
-       ! Read COSMO-DE soil type map
+!
+!--    Read COSMO soil type map
        cosmo_var % name = 'SOILTYP'
        CALL get_netcdf_variable(cfg % soiltyp_file, cosmo_var, soiltyp)
@@ -465,6 +486,6 @@
        CALL report('setup_parameters', message)
 
-
-       ! Read in COSMO-DE heights of half layers (vertical cell faces)
+!
+!--    Read in COSMO heights of half layers (vertical cell faces)
        cosmo_var % name = 'HHL'
        CALL get_netcdf_variable(cfg % hhl_file, cosmo_var, hhl)
@@ -486,5 +507,6 @@
  CALL run_control('time', 'comp')
 
-       ! Appoximate COSMO-DE heights of full layers (cell centres)
+!
+!--    Appoximate COSMO-DE heights of full layers (cell centres)
        ALLOCATE( hfl(nlon, nlat, nlev-1) )
        ALLOCATE( d_depth(ndepths), d_depth_rho_inv(ndepths) )
@@ -494,5 +516,6 @@
        d_depth_rho_inv = 1.0_dp / ( d_depth * RHO_L )
 
-       ! Appoximate COSMO-DE heights of full layers (cell centres)
+!
+!--    Appoximate COSMO-DE heights of full layers (cell centres)
        DO k = 1, nlev-1
           hfl(:,:,k) = 0.5_dp * ( hhl(:,:,k) +                                 &
@@ -506,13 +529,16 @@
 ! Section 4.2: PALM-4U parameters
 !------------------------------------------------------------------------------
-       ! PALM-4U domain extents
+!
+!--    PALM-4U domain extents
        lx = (nx+1) * dx
        ly = (ny+1) * dy
        
-       ! PALM-4U point of Earth tangency
+!
+!--    PALM-4U point of Earth tangency
        x0 = 0.0_dp
        y0 = 0.0_dp
 
-       ! time vector
+!
+!--    time vector
        nt = CEILING(end_time / (step_hour * 3600.0_dp)) + 1
        ALLOCATE( time(nt) )
@@ -521,5 +547,6 @@
  CALL run_control('time', 'init')
 
-! Convert the PALM-4U origin coordinates to COSMO's rotated-pole grid
+!
+!--    Convert the PALM-4U origin coordinates to COSMO's rotated-pole grid
        phi_c    = TO_RADIANS *                                                 &
                   phi2phirot( origin_lat * TO_DEGREES, origin_lon * TO_DEGREES,&
@@ -530,13 +557,15 @@
                               0.0_dp )
 
-! Set gamma according to whether PALM domain is in the northern or southern
-! hemisphere of the COSMO-DE rotated-pole system. Gamma assumes either the
-! value 0 or PI and is needed to work around around a bug in the rotated-pole
-! coordinate transformations.
+!
+!--    Set gamma according to whether PALM domain is in the northern or southern
+!--    hemisphere of the COSMO rotated-pole system. Gamma assumes either the
+!--    value 0 or PI and is needed to work around around a bug in the
+!--    rotated-pole coordinate transformations.
        gam = gamma_from_hemisphere(origin_lat, phi_equat)
 
-! Compute the north pole of the rotated-pole grid centred at the PALM-4U domain
-! centre. The resulting (phi_cn, lambda_cn) are coordinates in COSMO-DE's
-! rotated-pole grid.
+!
+!--    Compute the north pole of the rotated-pole grid centred at the PALM-4U
+!--    domain centre. The resulting (phi_cn, lambda_cn) are coordinates in
+!--    COSMO-DE's rotated-pole grid.
        phi_cn    = phic_to_phin(phi_c) 
        lambda_cn = lamc_to_lamn(phi_c, lambda_c) 
@@ -573,5 +602,6 @@
 !------------------------------------------------------------------------------
 
-    ! Compute coordiantes of the PALM centre in the source (COSMO) system
+!
+!-- Compute coordiantes of the PALM centre in the source (COSMO) system
     phi_centre = phirot2phi(                                                   &
        phirot = project(0.5_dp*ly, y0, EARTH_RADIUS) * TO_DEGREES,             &
@@ -595,6 +625,6 @@
     CALL report( 'setup_parameters', message )
 
-
-    ! Compute boundaries of the central averaging box
+!
+!-- Compute boundaries of the central averaging box
     averaging_angle = cfg % averaging_angle * TO_RADIANS
     lam_east = lam_centre + 0.5_dp * averaging_angle
@@ -605,5 +635,6 @@
     averaging_width_ns = averaging_angle * EARTH_RADIUS
 
-    ! Coriolis parameter
+!
+!-- Coriolis parameter
     f3 = 2.0_dp * OMEGA * SIN(                                                 &
        TO_RADIANS*phirot2phi( phi_centre * TO_DEGREES, lam_centre * TO_DEGREES,&
@@ -618,7 +649,8 @@
 ! Description:
 ! ------------
-!> Initializes the COSMO-DE, PALM-4U, PALM-4U boundary grids.
+!> Defines the COSMO, PALM-4U, PALM-4U boundary grids, in partucular their
+!> coordinates and interpolation weights
 !------------------------------------------------------------------------------!
-    SUBROUTINE setup_grids() ! setup_grids(inifor_settings(with nx, ny, nz,...))
+    SUBROUTINE setup_grids()
        CHARACTER ::  interp_mode
 
@@ -626,8 +658,8 @@
 ! Section 0: Define base PALM-4U grid coordinate vectors
 !------------------------------------------------------------------------------
-       ! palm x y z, we allocate the column to nz+1 in order to include the top
-       ! scalar boundary. The interpolation grids will be associated with
-       ! a shorter column that omits the top element.
-       
+!
+!--    palm x y z, we allocate the column to nz+1 in order to include the top
+!--    scalar boundary. The interpolation grids will be associated with
+!--    a shorter column that omits the top element.
        ALLOCATE( x(0:nx), y(0:ny), z(1:nz), z_column(1:nz+1) )
        CALL linspace(0.5_dp * dx, lx - 0.5_dp * dx, x)
@@ -642,6 +674,7 @@
        z_top = z_column(nz+1)
 
-       ! palm xu yv zw, compared to the scalar grid, velocity coordinates
-       ! contain one element less.
+!
+!--    palm xu yv zw, compared to the scalar grid, velocity coordinates
+!--    contain one element less.
        ALLOCATE( xu(1:nx),  yv(1:ny), zw(1:nz-1), zw_column(1:nz))
        CALL linspace(dx, lx - dx, xu)
@@ -661,5 +694,6 @@
                nx=nx, ny=ny, nz=nz, z=z, zw=zw, ic_mode=cfg % ic_mode)
 
-       ! Subtracting 1 because arrays will be allocated with nlon + 1 elements.
+!
+!--    Subtracting 1 because arrays will be allocated with nlon + 1 elements.
        CALL init_grid_definition('cosmo-de', grid=cosmo_grid,                  &
                xmin=lonmin, xmax=lonmax,                                       &
@@ -668,8 +702,9 @@
                nx=nlon-1, ny=nlat-1, nz=nlev-1)
 
-! Define intermediate grid. This is the same as palm_grid except with a much
-! coarser vertical grid. The vertical levels are interpolated in each PALM-4U
-! column from COSMO-DE's secondary levels. The main levels are then computed as
-! the averages of the bounding secondary levels.
+!
+!--    Define intermediate grid. This is the same as palm_grid except with a
+!--    much coarser vertical grid. The vertical levels are interpolated in each
+!--    PALM column from COSMO's secondary levels. The main levels are then
+!--    computed as the averages of the bounding secondary levels.
        CALL init_grid_definition('palm intermediate', grid=palm_intermediate,  &
                xmin=0.0_dp, xmax=lx,                                           &
@@ -1007,35 +1042,4 @@
                latmin = phi_south, latmax = phi_north,                         &
                kind='scalar')
-
-       profile_grids_required = ( TRIM(cfg % ic_mode) == 'profile' .OR.        &
-                                  TRIM(cfg % bc_mode) == 'ideal' )
-
-       !IF (profile_grids_required)  THEN
-       !   ! Here, I use the 'boundary' kind, so the vertical coordinate uses the
-       !   ! PALM z coordinate.
-       !   CALL init_grid_definition('boundary', grid=scalar_profile_grid,      &
-       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-       !           x0=x0, y0=y0, z0 = z0,                                       &
-       !           nx = 0, ny = 0, nz = nz, z=z)
-
-       !   CALL init_grid_definition('boundary', grid=w_profile_grid,           &
-       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-       !           x0=x0, y0=y0, z0 = z0,                                       &
-       !           nx = 0, ny = 0, nz = nz - 1, z=zw)
-
-       !   CALL init_grid_definition('boundary', grid=scalar_profile_intermediate,&
-       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-       !           x0=x0, y0=y0, z0 = z0,                                       &
-       !           nx = 0, ny = 0, nz = nlev - 2, z=z)
-
-       !   CALL init_grid_definition('boundary', grid=w_profile_intermediate,   &
-       !           xmin = 0.5_dp * lx, xmax = 0.5_dp * lx,                      &
-       !           ymin = 0.5_dp * ly, ymax = 0.5_dp * ly,                      &
-       !           x0=x0, y0=y0, z0 = z0,                                       &
-       !           nx = 0, ny = 0, nz = nlev - 2, z=zw)
-       !END IF
 
 !                                                                              
@@ -1091,4 +1095,10 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Driver for computing neighbour indices and weights for horizontal and
+!> vertical interpolation.
+!------------------------------------------------------------------------------!
     SUBROUTINE setup_interpolation(cosmo_grid, grid, intermediate_grid, kind, ic_mode)
 
@@ -1106,20 +1116,25 @@
 ! Section 1: Horizontal interpolation                                        
 !------------------------------------------------------------------------------
-       ! Select horizontal coordinates according to kind of points (s/w, u, v)
+!
+!--    Select horizontal coordinates according to kind of points (s/w, u, v)
        SELECT CASE(kind)
 
-       CASE('s') ! scalars
+!
+!--    scalars
+       CASE('s')
 
           cosmo_lat => cosmo_grid % lat
           cosmo_lon => cosmo_grid % lon
           cosmo_h   => cosmo_grid % hfl
-
-       CASE('w') ! vertical velocity
+!
+!--    vertical velocity
+       CASE('w')
 
           cosmo_lat => cosmo_grid % lat
           cosmo_lon => cosmo_grid % lon
           cosmo_h   => cosmo_grid % hhl
-
-       CASE('u') ! x velocity
+!
+!--    x velocity
+       CASE('u')
 
           cosmo_lat => cosmo_grid % lat
@@ -1127,5 +1142,7 @@
           cosmo_h   => cosmo_grid % hfl
 
-       CASE('v') ! y velocity
+!
+!--    y velocity
+       CASE('v')
 
           cosmo_lat => cosmo_grid % latv
@@ -1153,10 +1170,11 @@
 !------------------------------------------------------------------------------
 
-       ! If profile initialization is chosen, we--somewhat counterintuitively--
-       ! don't need to compute vertical interpolation weights. At least, we
-       ! don't need them on the intermediate grid, which fills the entire PALM
-       ! domain volume. Instead we need vertical weights for the intermediate
-       ! profile grids, which get computed in setup_averaging().
-       setup_volumetric = .TRUE.
+!
+!--    If profile initialization is chosen, we--somewhat counterintuitively--
+!--    don't need to compute vertical interpolation weights. At least, we
+!--    don't need them on the intermediate grid, which fills the entire PALM
+!--    domain volume. Instead we need vertical weights for the intermediate
+!--    profile grids, which get computed in setup_averaging().
+!--    setup_volumetric = .TRUE.
        IF (PRESENT(ic_mode))  THEN
           IF (TRIM(ic_mode) == 'profile')  setup_volumetric = .FALSE.
@@ -1169,6 +1187,7 @@
           intermediate_grid % h(:,:,:) = - EARTH_RADIUS
 
-          ! For w points, use hhl, for scalars use hfl
-          ! compute the full heights for the intermediate grids
+!
+!--       For w points, use hhl, for scalars use hfl
+!--       compute the full heights for the intermediate grids
           CALL interpolate_2d(cosmo_h, intermediate_grid % h, intermediate_grid)
           CALL find_vertical_neighbours_and_weights_interp(grid, intermediate_grid)
@@ -1246,5 +1265,6 @@
            grid % z => z
 
-           ! Allocate neighbour indices and weights
+!
+!--        Allocate neighbour indices and weights
            IF (TRIM(ic_mode) .NE. 'profile')  THEN
               ALLOCATE( grid % kk(0:nx, 0:ny, 1:nz, 2) )
